#include "forms.h"
#include "clock.h"
#include <X11/Xutil.h>
#include <pwd.h>
#include <sys/types.h>           

int h=80;
int w=80;
FL_OBJECT * timer;
struct passwd * pwentry;
FILE * rcf;
char homedir[1024];

FD_clock *create_form_clock(void)
{
  FL_OBJECT *obj;
  FD_clock *fdui = (FD_clock *) fl_calloc(1, sizeof(FD_clock));

  fdui->clock = fl_bgn_form(FL_NO_BOX, w, h);
  obj = fl_add_box(FL_UP_BOX,0,0, w, h, "");
  fdui->clock1 = obj = fl_add_clock(FL_ANALOG_CLOCK,0,0,w,h,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
  timer = fl_add_timer(FL_HIDDEN_TIMER,1,1,2,2,""); 

  fl_end_form();
  return fdui;
}

/* callbacks for form clock */
usage()
{
  puts("Usage");
  puts("     -display host:dpy");
  puts("           specifies the server to connect to.");
  puts("     -geometry GEOMSTRING");
  puts("           specifies the placement of the window.");

                                       
  exit(0);
}
update_clockrc()
{
  static FL_Coord oldx=0, oldy=0, oldw=0, oldh=0;
  unsigned int ijunk;
  FL_Coord x, y, w, h, h1,w1;
  Window parent,wjunk;
  Window * wpjunk;

  fl_get_wingeometry(fl_winget(), &x, &y,
		     &w,&h);
  XQueryTree( fl_get_display(), fl_winget(),
	     &wjunk, &parent,
	     &wpjunk, &ijunk);
  XQueryTree( fl_get_display(), parent,
	     &wjunk, &parent,
	     &wpjunk, &ijunk);

  fl_get_wingeometry(parent, &x, &y,
		     &w1,&h1);

  if ((x!=oldx) || (y!=oldy) || (h!=oldh) || (w!=oldw))
      {
	oldx=x;	oldy=y;	oldh=h;	oldw=w;
	pwentry=getpwuid(getuid());
	strcpy(homedir,pwentry->pw_dir);
	strcat(homedir,"/.fclockrc");
	rcf=fopen(homedir,"w");
	fprintf(rcf,"%ix%i%c%i%c%i\n",w,h,
		(x>=0)?'+':'-',
		x,
		(y>=0)?'+':'-',
		y);
	fclose(rcf);
      }
}
 
int main(int argc, char *argv[])
{
   FD_clock *fd_clock;
   Display * dpy;

   int x=0,y=682;
   int rh,rw,junk,gflags;
   Window wjunk;
   FILE * flrc;
   FL_IOPT flopt;
   char geomline[60];

   flopt.debug=0;
   flopt.doubleBuffer=1;

   fl_set_defaults(FL_PDDebug| FL_PDDouble,
                  &flopt);                                                    

#if FL_REVISION>=80
   dpy=fl_initialize(&argc, argv, "fclock", 0, 0);
#else
   dpy=fl_initialize(argv[0], "fclock", 0, 0, &argc, argv);
#endif

   if (argc == 1) 
     {
       pwentry=getpwuid(getuid());
       strcpy(homedir,pwentry->pw_dir);
       strcat(homedir,"/.fclockrc");
       rcf=fopen(homedir,"r");
       if (rcf==NULL) goto run;
       fgets(geomline,60,rcf);
       fclose(rcf);
       geomline[strlen(geomline)-1]=0;
       gflags=XParseGeometry(geomline,&x,&y,&w,&h);
       XGetGeometry(dpy,XDefaultRootWindow(dpy),
		    &wjunk,&junk,&junk,&rw,&rh,
		    &junk,&junk);
       if (gflags & XNegative ) {x=rw-w+x;printf("Xneg %i\n",x);}
       if (gflags & YNegative ) {y=rh-h+y;printf("Yneg %i\n",y);}
       goto run;
     }
   if ( argc!=3) usage();
   
   if (argc == 3)
     {
       if (strcmp("-geometry",argv[1])==0
	   || strcmp("-g",argv[1])==0)
	 {
	   gflags=XParseGeometry(argv[2],&x,&y,&w,&h);
	   XGetGeometry(dpy,XDefaultRootWindow(dpy),
			&wjunk,&junk,&junk,&rw,&rh,
			&junk,&junk);
	   if (gflags & XNegative ) {x=rw-w+x-8;printf("Xneg %i\n",x);}
	   if (gflags & YNegative ) {y=rh-h+y-8;printf("Yneg %i\n",y);}

	 }
       else usage();
     }

 run:
   fd_clock = create_form_clock();

   /* fill-in form initialization code */

   /* show the first form */
   fl_set_form_position(fd_clock->clock,x,y);
   fl_show_form(fd_clock->clock,FL_PLACE_GEOMETRY,FL_FULLBORDER,"Clock");

   fl_set_timer(timer,0.5);
#if FL_REVISION>=80
   fl_set_form_minsize(fd_clock->clock,40,40);
   fl_set_form_maxsize(fd_clock->clock,800,800);
#else
   fl_min_winsize(fl_winget(),40,40);
   fl_max_winsize(fl_winget(),800,800);
#endif

   while(1)
     {
       FL_Coord x, y, w, h; 
       fl_do_forms();
       fl_set_timer(timer,0.5);
       update_clockrc();
     }
   return 0;
}

